----------------------------------------------
-- Panasonic KXTD over TCP/IP
-- Scannex Electronics Ltd. www.scannex.co.uk
-- MP 2012-09-17
-- MP 2012-09-19  Simplified and updated
----------------------------------------------
protocols.kxtdip={}
protocols.kxtdip.desc="Panasonic KX-TD TCP/IP [port 2300] (20120919)"
protocols.kxtdip.params="T;pass;Password;Password;PCCSMDR"
protocols.kxtdip.bidi=1
protocols.kxtdip.matchsend=0
protocols.kxtdip.only="tcp"

function protocols.kxtdip._error(p,msg)
 p:error(msg)
 p:close()
end

function protocols.kxtdip.setup(p)
 if (c.chnl[p.n].src.tcp.passive~=0) or
    (c.chnl[p.n].src.tcp.ssl=='i')
 then
  c.chnl[p.n].src.tcp.passive=0
  c.chnl[p.n].src.tcp.ssl=NULL
  return true
 end
end

function protocols.kxtdip.connect(p)
 local s,b,t
 p._error=protocols.kxtdip._error
 while true
 do
  s,t=p:read(1,10000)
  if t then return p:_error("Timed out (no prompt)") end
  if string.find(s,"-",1,true) then break end
 end
 p:write("SMDR\r\n")
 b=""
 while true
 do
  s,t=p:read(1,10000)
  if t then return p:_error("Timed out (no password request)") end
  b=b..s
  if string.find(b,"word:",1,true) then break end
 end
 p:write(p.pass.."\r\n") 
end

function protocols.kxtdip.data(p)
 local s=p:readline()
 s=string.gsub(s,"[\xff\x7f]","")
 p:store(s,"cdr panasonic")
end

